#include <stdio.h>
#include <GL/gl.h>
#include <GL/glut.h>
#include <GL/glu.h>
#include <unistd.h>
#include <stdlib.h>
#include <GL/glui.h>

int spin_x = 0, old_x = 0;		// spin_ indica di quanto si deve ruotare la scena
int spin_y = 0, old_y = 0;		// old_  indica la vecchia posizione del cursore

int fase = 0;
int FPS = 40;
double angle[10];

double sole = 1;
double terra;

GLUI_EditText *dimensione;
GLUI_Checkbox *disegna;

int main_window;


void drawPlanet(double,double,double,double,char*);


void draw() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //Imposto buffer colore, buffer parti nascoste
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(2, 2, 6, 0, 0, 0, 0, 1, 0); //Definisce punto di vista
	
	terra = sole/108;
	//Codice disegno
	if(disegna->get_int_val()) {
		glColor3d(0.97, 0.76, 0.105);
		drawPlanet(0, 0, (angle[0]), sole,"So");
	}
	glColor3d(0.67, 0.51, 0.27);
	drawPlanet(-1.4, 0, (angle[1]+2), terra*0.38,"Me");
	glColor3d(0.52, 0.38, 0.15);
	drawPlanet(1.8, 0, (angle[2]+5), terra*0.94,"Ve");
	glColor3d(0.13, 0.65, 0.86);
	drawPlanet(-2.2, 0, (angle[3]), terra,"Te");
	glColor3d(0.69, 0.24, 0.24);
	drawPlanet(2.6, 0, (angle[4]+44), terra*0.532,"Ma");
	glColor3d(0.63, 0.58, 0.52);
	drawPlanet(-3.0, 0, (angle[5]+12), terra*11.2,"Gi");
	glColor3d(0.97, 0.84, 0.62);
	drawPlanet(3.4, 0, (angle[6]+6), terra*9.4,"Sa");
	glColor3d(0.59, 0.68, 0.73);
	drawPlanet(3.8, 0, (angle[7]+22), terra*4,"Ur");
	glColor3d(0.26, 0.33, 0.47);
	drawPlanet(-3.9, 1, (angle[8]+18), terra*3.88,"Ne");
	glColor3d(0.27, 0.27, 0.27);
	drawPlanet(4, 0, (angle[9]+88), terra*0.18,"Pl");
	
	
	glFlush();
	glutSwapBuffers();
	
}	


void initLights() { //Inizializza luci
	// colore e tipo delle luci	
	GLfloat light_ambient_0[] =	{0.65, 0.65, 0.65, 1.0};// colore ambiente della luce 0
	GLfloat light_diffuse_0[] = {1.0, 1.0, 1.0, 1.0};	// colore diffusione della luce 0
	GLfloat light_specular_0[] = {1.0, 1.0, 1.0, 1.0};	// colore speculare della luce 0
	GLfloat light_position_0[] = {5.0, 5.0, 0.0, 0.0};	// posizione della luce 0
	
	glLightfv (GL_LIGHT0, GL_AMBIENT,	light_ambient_0);
	glLightfv (GL_LIGHT0, GL_DIFFUSE,	light_diffuse_0);
	glLightfv (GL_LIGHT0, GL_SPECULAR,	light_specular_0);
	glLightfv (GL_LIGHT0, GL_POSITION,	light_position_0);
	
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
}

void initEngine() { //Inializzazioni varie
	glShadeModel (GL_FLAT); 
    
	glClearColor (0.0, 0.0, 0.0, 0.0);
	
	
	initLights();
	
	glMatrixMode(GL_PROJECTION); //Imposto la matrice per la proiezione
	glLoadIdentity(); //Carico Matrice identità (Reset matrice impostata)
	gluPerspective(45.0, (1280.0/800.0), 0.1, 500); //Proiezione Prospettica
	//glOrtho(-5, +5, -5, +5, 0.1, 800); //Proiezione Parallela 
	
	
	glClearDepth(1.0f); //Inializza Buffer parti nascoste	
	glEnable(GL_DEPTH_TEST); //abilita calcolo parti nascoste
	glDepthFunc(GL_LEQUAL);
	
}

//Ascoltatore tastiera
void keyListener(unsigned char c, int x, int y) {
	switch (c) {
		case 'q':
			exit(0);
			break;
		case 'a':
			fase = 1;
			break;
		case 's':
			fase = 0;
			break;
		default:
			break;
	}
	
	
}

//Ascoltatore mouse
void mouseListener(int button, int c, int x, int y) {
	
}

//Ascoltatore movimento mouse
void mouseMotion(int x, int y) {
	
	
	
}

//Ascoltatore menu
void menu(int op) {
	
	switch(op) {
		case 'a':
			fase = 1;
			break;
		case 'f':
			fase = 0;
			break;
			
		case 'Q':
		case 'q':
			exit(0);
	}
}

void buttonListener_OK() {
	sole = dimensione->get_float_val();
	fase = 1;
	
}



void buttonListener_Stop() {
	fase = 0;
}

void animation(int t)
{
	switch (fase) {
		case 0: // fase di pausa
			break;
		case 1: // prima fase di animazione
		{
			int i;
			double j;
			for (i = 0, j = 2; i < 10; i++, (j=j-0.2)) {
				angle[i] = angle[i]+j;
			}
			glutPostRedisplay();
			break;
		}
	}
	glutTimerFunc((int) 1000/FPS, animation, 0);
	// La glutTimerFunc funziona come una sveglia che squilla una volta dopo x millisecondi. 
	// Se si vuole che suoni (si richiami) di nuovo bisogn ri-invocarla
}

void idle() { }


void myGlutIdle() { 
	glutSetWindow(main_window); 
	glutPostRedisplay();
}


int main (int argc, char ** argv) {
	
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB |GLUT_DEPTH); //GLUT_DEPTH inizializza finestra calcolo parti nascoste
	glutInitWindowSize (1280, 800);
	//glViewport (0, 0, 500, 500); //Finestra di visualizzazione
	glutInitWindowPosition (0, 0);
	main_window = glutCreateWindow ("Sistema Solare");
	glutDisplayFunc(draw); //Funzione di disegno
	glutKeyboardFunc(keyListener); //Ascoltatore Tastiera
	glutMouseFunc(mouseListener); //Ascoltatore Mouse
	glutMotionFunc(mouseMotion); //Ascoltatore Movimenti mouse  
	glutTimerFunc((int) 1000/FPS, animation, 0);
	glutIdleFunc(idle);
	
	//GLUI
	GLUI *glui = GLUI_Master.create_glui_subwindow(main_window, 0);
	glui->add_statictext( "Sistema Solare" );
	dimensione = glui->add_edittext("Dimensione sole:",GLUI_EDITTEXT_FLOAT);
	disegna = glui->add_checkbox("Visualizza Sole");
	dimensione->set_float_val((float)sole);
	disegna->set_int_val(1);
	glui->add_button("ok - avvia",0, (GLUI_Update_CB)buttonListener_OK);
	glui->add_button("Stop", 0, (GLUI_Update_CB)buttonListener_Stop);
	GLUI_Master.set_glutKeyboardFunc(keyListener);
	GLUI_Master.set_glutMouseFunc(mouseListener);
	GLUI_Master.set_glutIdleFunc(myGlutIdle);
	
	//Menù tasto destro
	glutCreateMenu(menu);
	glutAddMenuEntry("Avvia animazione", 'a');
	glutAddMenuEntry("Ferma animazione", 'f');
	glutAddMenuEntry("Quit", 'q');
	glutAttachMenu(GLUT_RIGHT_BUTTON);
    
	
	initEngine();
	glutMainLoop();	
}


void drawPlanet(double x, double y, double riv, double dim, char* n) {
	
	glPushMatrix();
	glRotated(riv, 0, 1, 0); //Rivoluzione
	glTranslated(x, y, 0);
	glRotated(riv*4, 0, 1, 0); //Rotazione sul proprio asse
	glutSolidSphere(dim, 500, 500);
	glPopMatrix();
	
	glPushMatrix();
	glDisable(GL_LIGHTING);
	glRotated(riv, 0, 1, 0); //Rivoluzione
	glColor3f(0,0,1);
	glRasterPos3f(x, y+0.2, 0.0);
	glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, n[0]);
	glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, n[1]);
	
	glEnable(GL_LIGHTING);
	
	
	glPopMatrix();
	
}
